import java.util.Collection;

public abstract class AcaoAbstrata implements Visitante {

    protected final String nome;
    protected int alcanceDaAcao;
    protected PadraoDoEfeito padraoDoEfeito;
    protected int extensaoDoEfeito;
    protected Unidade agente;

    public AcaoAbstrata( String nome, int alcanceDaAcao, 
                         PadraoDoEfeito padraoDoEfeito, int extensao ) {
    
        this.nome = nome;
	this.alcanceDaAcao = alcanceDaAcao;
	this.padraoDoEfeito = padraoDoEfeito;
	this.extensaoDoEfeito = extensao;
    }

    public String recuperaNome() {
        
        return nome;
    }

    public int recuperaAlcanceDaAcao() {
	
	return alcanceDaAcao;
    }

    public void alteraAlcanceDaAcao( int novoAlcanceDaAcao ) {
    
	this.alcanceDaAcao = novoAlcanceDaAcao;
    }

    public abstract void executa( Unidade paciente );

    public Collection calculaArea() {
        
        return this.padraoDoEfeito.calculaArea( this.extensaoDoEfeito );
    }
    
    public void associaAgente( Unidade agente ) {
	
	this.agente = agente;
    }

    public String toString() {
        
        return this.nome;
    }
}
