import java.util.HashMap;

/**
 * 
 * @version 1.0
 * @author Alex Minoru Kusano & Marcos Roberto Yukio Koga
 */
public class FabricaDeUnidades {
    
    private HashMap prototipos;

    private static FabricaDeUnidades instancia;

    private FabricaDeUnidades() {
    
	prototipos = new HashMap();
    }

    public static FabricaDeUnidades recuperaInstancia() {
        
        if( instancia == null ) {
            instancia = new FabricaDeUnidades();
        }
        return instancia;
    }

    public Unidade criaUnidade( String nomeDoPrototipo ) {
	
	Unidade original = ( Unidade )prototipos.get( nomeDoPrototipo );
	return ( Unidade ) original.clone();
    }
    
    public void adicionaPrototipo( String nomeDoPrototipo, 
				   Unidade prototipo ) {
    
	prototipos.put( nomeDoPrototipo, prototipo );
    }
    
    public Unidade[] recuperaPrototipos() {
        
        Unidade[] retorno = new Unidade[ prototipos.size() ];
	prototipos.values().toArray( retorno );
	return retorno;
    }
}
