import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class JanelaDimensoes extends JDialog {

    private CampoNumeroInteiro x;
    private CampoNumeroInteiro y;

    private Coordenada escolha;

    public JanelaDimensoes( JFrame dono ) {
        
        super( dono, "Escolha as dimenses", true );
        inicializaComponentes();

        pack();
        show();
    }

    public void inicializaComponentes() {

        x = new CampoNumeroInteiro( 3 );
        y = new CampoNumeroInteiro( 3 );

        JPanel painelAtributos = new JPanel( new GridLayout( 2, 2 ) );
        painelAtributos.add( new JLabel( "x:" ) );
        painelAtributos.add( x );
        painelAtributos.add( new JLabel( "y:" ) );
        painelAtributos.add( y );

        JPanel painelBotoes = new JPanel( new FlowLayout() );

        JButton botaoCancelar = new JButton( " cancelar " );
        botaoCancelar.addActionListener( new ActionListener() {
            
                public void actionPerformed( ActionEvent ae ) {
                    
                    hide();
                }
            } );

        JButton botaoConfirmar = new JButton( "confirmar" );
        botaoConfirmar.addActionListener( new ActionListener() {
            
                public void actionPerformed( ActionEvent ae ) {
                    
		    if(  x.getValue() <= 0 ) {
			JOptionPane.showMessageDialog( JanelaDimensoes.this,
		             "Por favor, entre com um valor positivo para x.", 
				           "Erro", JOptionPane.ERROR_MESSAGE);
			return;
		    }
		    if(  y.getValue() <= 0 ) {
			JOptionPane.showMessageDialog( JanelaDimensoes.this,
		             "Por favor, entre com um valor positivo para y.", 
				           "Erro", JOptionPane.ERROR_MESSAGE);
			return;
		    }
                    escolha = new Coordenada( x.getValue(), y.getValue() );
                    hide();
                }
            } );

        painelBotoes.add( botaoCancelar );
        painelBotoes.add( botaoConfirmar );

        Container c = getContentPane();
        
        c.setLayout( new BorderLayout() );
        c.add( painelAtributos, BorderLayout.NORTH );
        c.add( painelBotoes, BorderLayout.SOUTH );
    }

    public Coordenada recuperaEscolha() {

        return escolha;
    }

    public static void main( String[] args ) {

        JanelaDimensoes jd = new JanelaDimensoes( null );
        Coordenada c = jd.recuperaEscolha();
        if( c != null ) {
            System.out.println( c.recuperaX() + " " +  c.recuperaY() );
        }
    }
}
