import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import javax.swing.Box;
import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.DefaultListSelectionModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;

public class JanelaEscolhaUnidades extends JFrame {

    private DefaultListModel modeloDisponiveis;
    private JList unidadesDisponiveis;
    private DefaultListModel modeloEscolhidos;
    private JList unidadesEscolhidas;
    
    private JLabel nomeJogador;
    private CampoNumeroInteiro restantes;

    private Jogador[] jogadores;
    private int jogadorAtual;

    public JanelaEscolhaUnidades() {
        
        super( "Escolha suas unidades" );
        inicializaComponentes();

        addWindowListener( new WindowAdapter() {	
		public void windowClosing( WindowEvent we ) {                 
                    System.exit(0);
                }
	    } );

        proximoJogador();
    }
    
    public void inicializaComponentes() {

        jogadores = Gerenciador.recuperaInstancia().recuperaJogadores();
        jogadorAtual = 0;

	JPanel painelPrincipal = new JPanel( new BorderLayout() );

	nomeJogador = new JLabel( " " );

        JPanel painelUnidades = new JPanel( new GridLayout( 1, 3 ) );

        modeloDisponiveis = new DefaultListModel();
        unidadesDisponiveis = new JList( modeloDisponiveis );

	unidadesDisponiveis.setSelectionMode( 
                     DefaultListSelectionModel.SINGLE_SELECTION );

        painelUnidades.add( new JScrollPane( unidadesDisponiveis ) );

        Unidade[] unidades = 
            Gerenciador.recuperaInstancia().recuperaPrototipos();
        
        for( int i = 0; i< unidades.length; i++ ) {
            modeloDisponiveis.addElement( unidades[i] );
        }

        JPanel painelBotoes = new JPanel( new GridBagLayout() );
        
        GridBagConstraints gbc = new GridBagConstraints();     

        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.weightx = 1;
        gbc.weighty = 1;
        gbc.gridx = 0;
        gbc.gridy = 0;

        JButton botaoIncluir = new JButton( "incluir" );

        botaoIncluir.addActionListener( new ActionListener() {
            
                public void actionPerformed( ActionEvent ae ) {

                    if( restantes.getValue() == 0 ) {
			JOptionPane.showMessageDialog( 
                                                  JanelaEscolhaUnidades.this,
		             "Ateno, voc no pode mais incluir unidades.", 
				      "Ateno", JOptionPane.WARNING_MESSAGE);
			return;
		    }

		    Unidade unidade = 
			( Unidade ) unidadesDisponiveis.getSelectedValue();

		    if( unidade == null ) {
			JOptionPane.showMessageDialog( 
                                                  JanelaEscolhaUnidades.this,
		               "Por favor, selecione um elemento primeiro.", 
				           "Erro", JOptionPane.ERROR_MESSAGE);
			return;
		    }

		    Box painelQde = Box.createHorizontalBox();
                    CampoNumeroInteiro qde = new CampoNumeroInteiro( 3 );
                    painelQde.add( new JLabel( "Digite a quantidade: " ) );
                    painelQde.add( qde );

                    qde.setValue(0);

                    JOptionPane.showMessageDialog( JanelaEscolhaUnidades.this,
						   painelQde, "Quantos?", 
					       JOptionPane.QUESTION_MESSAGE );

		    int quant = qde.getValue();
		    
                    if( quant != 0 ) {
			if( quant > restantes.getValue() ) {
                            
                            int escolha = 
                                JOptionPane.showConfirmDialog( 
                                                  JanelaEscolhaUnidades.this ,
                               " Com a quantidade de unidades especificadas" +
                            "\nvoc excede o nmero de unidades permitidas." +
                                      "\n Deseja incluir o mximo possvel?" ,
                                                       "Excesso de unindades",
                                                   JOptionPane.YES_NO_OPTION );
                            if( escolha == JOptionPane.YES_OPTION ) {
                                quant = restantes.getValue();
                            }
                            else {
                                return;
                            }
                        } 

			ItemDaLista item = new ItemDaLista( unidade, quant );
			if( modeloEscolhidos.contains( item ) ) {
			    int idx = modeloEscolhidos.indexOf( item );
			    item = ( ItemDaLista )
				modeloEscolhidos.getElementAt( idx );
			    item.alteraQuantidade( quant );
                            unidadesEscolhidas.repaint();
			}
			else {
			    modeloEscolhidos.addElement( item );
			}
                        restantes.setValue( restantes.getValue() - quant );
		    }
                }
            } ); 
        
        painelBotoes.add( botaoIncluir, gbc );

        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc.weightx = 1;
        gbc.weighty = 1;
        gbc.gridx = 0;
        gbc.gridy = 1;

        JButton botaoExcluir = new JButton( "excluir" );
        botaoExcluir.addActionListener( new ActionListener() {
            
                public void actionPerformed( ActionEvent ae ) {

                    Object[] itens = unidadesEscolhidas.getSelectedValues();
                    for( int i = 0; i < itens.length; i++ ) {
                        ItemDaLista item = ( ItemDaLista )itens[i];
                        restantes.setValue( restantes.getValue() +
                                            item.recuperaQuantidade() );
                        modeloEscolhidos.removeElement( item );
                    }
                }
            } ); 
        painelBotoes.add( botaoExcluir, gbc );

        painelBotoes.setBorder( 
                      BorderFactory.createEmptyBorder( 10, 10, 10, 10 ) );

        painelUnidades.add( painelBotoes );

        modeloEscolhidos = new DefaultListModel();
        unidadesEscolhidas = new JList( modeloEscolhidos );

        painelUnidades.add( new JScrollPane( unidadesEscolhidas ) );

        painelUnidades.setBorder( 
              BorderFactory.createCompoundBorder( 
                    BorderFactory.createTitledBorder( "Unidades" ),
                    BorderFactory.createEmptyBorder( 5, 5, 5, 5 ) ) );

	JPanel painelRestantes = 
	    new JPanel( new FlowLayout( FlowLayout.RIGHT ) );

	restantes = new CampoNumeroInteiro( 5 );
	restantes.setEditable( false );

	painelRestantes.add( new JLabel( "Restantes: " ) );
	painelRestantes.add( restantes );

	painelPrincipal.add( nomeJogador, BorderLayout.NORTH );
	painelPrincipal.add( painelUnidades, BorderLayout.CENTER );
	painelPrincipal.add( painelRestantes, BorderLayout.SOUTH );

        painelPrincipal.setBorder( 
              BorderFactory.createCompoundBorder(
                    BorderFactory.createEtchedBorder(),
                    BorderFactory.createEmptyBorder( 5, 5, 5, 5) ) );

        JPanel painelProximo = new JPanel( new BorderLayout() );

        JButton botaoProximo = new JButton( "Prosseguir" );        
        botaoProximo.addActionListener( new ActionListener() {
                
                public void actionPerformed( ActionEvent ae ) {

                    if( modeloEscolhidos.size() == 0 ) {
                        JOptionPane.showMessageDialog( 
                                                  JanelaEscolhaUnidades.this,
                    "Ateno,  preciso especificar pelo menos uma unidade", 
				           "Erro", JOptionPane.ERROR_MESSAGE);
                        return;
                    }

                    Gerenciador gerenciador = 
                        Gerenciador.recuperaInstancia();
                    for( int i = 0; i < modeloEscolhidos.size(); i++ ) {
                        ItemDaLista item = 
                            ( ItemDaLista )modeloEscolhidos.getElementAt( i );
                        for( int j = 0; j < item.recuperaQuantidade(); j++ ) {
                            gerenciador.criaUnidade(
                                     item.recuperaUnidade().recuperaNome(),
                                     jogadorAtual ) ;
                        }
                    }
                    if( ++jogadorAtual < 
                        gerenciador.recuperaTotalJogadores() ) {
                        
                        proximoJogador();
                        return;
                    }
                    JanelaEscolhaPosicoes proximaJanela = 
                        new JanelaEscolhaPosicoes();

                    dispose();
		    proximaJanela.setSize( 540, 400 );
                    proximaJanela.show();
                }
            } );

        painelProximo.add( botaoProximo, BorderLayout.EAST );

	Container c = getContentPane();
	c.setLayout( new BorderLayout() );
	c.add( painelPrincipal, BorderLayout.CENTER );
        c.add( painelProximo, BorderLayout.SOUTH );
    }

    public void proximoJogador() {
        
        nomeJogador.setText( jogadores[ jogadorAtual ].recuperaNome() );
        restantes.setValue( 
                  jogadores[ jogadorAtual ].recuperaTotalDeUnidades() );
        modeloEscolhidos.removeAllElements();
    }

    public static void main( String[] args ) {

	Gerenciador gerenciador = Gerenciador.recuperaInstancia();
        
        gerenciador.criaPrototipo( "teste",
                                   250, 20, 5,
				   null,
                                   new AcaoAbstrata[0] );
	gerenciador.criaPrototipo( "vivi",
                                   250, 20, 5,
				   "vivisit.gif",
                                   new AcaoAbstrata[0] );
        gerenciador.novoJogador();

        gerenciador.alteraTotalDeUnidades( 1, 13 );

        gerenciador.novoJogador();

        gerenciador.alteraTotalDeUnidades( 2, 12 );

	JFrame jf = new JanelaEscolhaUnidades();
	jf.pack();
	jf.show();
    }

    private class ItemDaLista {
	
	private Unidade unidade;
	private int quantidade;

	public ItemDaLista( Unidade unidade, int quantidade ) {
	    this.unidade = unidade;
	    this.quantidade = quantidade;
	}

	public Unidade recuperaUnidade() {
	    
	    return this.unidade;
	}

	public int recuperaQuantidade() {
	    
	    return this.quantidade;
	}

	public void alteraQuantidade( int incremento ) {
	    
	    this.quantidade += incremento;
	} 

	public String toString() {
	    
	    return ( unidade.recuperaNome() + " x " + quantidade );
	}

	public boolean equals( Object objeto ) {
	
	    if( ! getClass().isInstance( objeto ) ) {
		return false;
	    }
	    ItemDaLista item = ( ItemDaLista )objeto;
	    return this.unidade.equals( item.recuperaUnidade() );
	}
    }
}

