import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Component;
import java.awt.Toolkit;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.Box;
import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.JOptionPane;


/**
 *
 * @version 1.0
 * @author Alex Minoru Kusano & Marcos Roberto Yukio Koga
 */
public class JanelaNumeroJogadores extends JFrame {


    /** Campo de texto para o nmero de jogadores. */
    private CampoNumeroInteiro txtNumero;


    public JanelaNumeroJogadores() {

	super( "Nmero de jogadores" );
	inicializaComponentes();
        addWindowListener( new WindowAdapter() {	
		public void windowClosing( WindowEvent we ) {                 
                    System.exit(0);
                }
	    } );
    }


    private void inicializaComponentes() {

	txtNumero = new CampoNumeroInteiro( 2, 5 );
	txtNumero.setHorizontalAlignment( JTextField.RIGHT );
	
	Box painelDados = Box.createHorizontalBox();
	painelDados.add( new JLabel( "Nmero de jogadores:" ) );
	painelDados.add( Box.createHorizontalStrut( 10 ) );
	painelDados.add( txtNumero );

	JPanel painelCentral = new JPanel( new FlowLayout() );
	painelCentral.add( painelDados, BorderLayout.SOUTH );
	painelCentral.setAlignmentY( Component.CENTER_ALIGNMENT );	


	JButton botaoProsseguir = new JButton( "Prosseguir" );
        botaoProsseguir.setToolTipText( "clique aqui para continuar" );
	botaoProsseguir.addActionListener( new Prosseguir() );

	JPanel painelSul = new JPanel( new BorderLayout() );
	painelSul.add( botaoProsseguir, BorderLayout.EAST );
	painelSul.setBorder( BorderFactory.createEmptyBorder( 3, 0, 0, 0 ) );

	Container container = this.getContentPane();
	container.setLayout( new BorderLayout() );
	container.add( new JScrollPane( painelCentral ), BorderLayout.CENTER );
	container.add( painelSul, BorderLayout.SOUTH );
  }


    private class Prosseguir implements ActionListener {

	public void actionPerformed( ActionEvent ae ){

	    String numeroDigitado = txtNumero.getText().trim();
	    int numero;

	    // Verifica se o campo nmero de jogadores est vazio
	    if( numeroDigitado.equals( "" ) ) {
		Toolkit.getDefaultToolkit().beep();
		txtNumero.requestFocus();

		// Consertar frame principal...
		JOptionPane.showMessageDialog( JanelaNumeroJogadores.this, 
		       "Por favor, digite o nmero de jogadores.", "Erro",
		       JOptionPane.ERROR_MESSAGE);
		return;
	    }

	    // Verifica se o nmero de jogadores  vlido
	    numero = Integer.parseInt( numeroDigitado );
	    if( numero < 2 ) {
		Toolkit.getDefaultToolkit().beep();
		txtNumero.requestFocus();

		// Consertar frame principal...
		JOptionPane.showMessageDialog( JanelaNumeroJogadores.this, 
		       "O nmero mnimo de jogadores  dois.", "Erro",
			JOptionPane.ERROR_MESSAGE);
		return;
	    }

	    // Inicia o jogo com o nmero de jogadores especificado
	    Gerenciador.recuperaInstancia().novoJogo( numero );
	    JanelaCriacaoMapa proximaJanela = new JanelaCriacaoMapa( 15, 10 );
	    dispose();
	    proximaJanela.setSize( 540, 400 );
	    proximaJanela.show();
	}

    }


    public static void main( String[] args ) {
        
        JFrame janela = new JanelaNumeroJogadores();
	janela.setSize(540, 400);
        janela.show();
    }
}






