import java.util.ArrayList;

/**
 * 
 * @version 1.0
 * @author Alex Minoru Kusano & Marcos Roberto Yukio Koga
 */
public class Jogador implements Observado {

    String nome;
    ArrayList unidades;

    ArrayList observadores;


    int totalUnidades;

    
    public Jogador( String nome ) {
	
	this.nome = nome;
	this.unidades = new ArrayList();
	this.observadores = new ArrayList();
    }

    public String recuperaNome() {
        
        return this.nome;
    }

    public boolean adicionaUnidade( Unidade unidade ) {
	
	// Verifica se ainda pode adicionar unidades 
	if( unidades.size() < totalUnidades ) {
	    unidades.add( unidade );
	    return true;
	}
	
	return false;
    }
    
    public void removeUnidade( Unidade unidade ) {
    
	int idx = unidades.indexOf( unidade );
	if( idx != -1 ) {
	    unidades.remove( idx );
	    totalUnidades--;

	    if( totalUnidades == 0 ) {
		notificaObservadores( this );
	    }
	}
    }

    
    public Unidade[] recuperaUnidades() {
	
	Unidade[] retorno = new Unidade[ unidades.size() ];
	unidades.toArray( retorno );
	return retorno;
    }

    public AcaoAbstrata[] recuperaAcoes( Unidade unidade ) {
	
	return unidade.recuperaAcoes();
    }

    public void executaAcao( Unidade unidade, AcaoAbstrata acao ) {
	
	unidade.executaAcao( acao );
    }

    public Setor recuperaPosicao( Unidade unidade ) {
	
	return unidade.recuperaPosicao();
    }
    
    public int recuperaPontosDeMovimento( Unidade unidade ) {
	
	return unidade.recuperaPontosDeMovimento();
    }

    public void move( Unidade unidade, Setor posicao ) {
	
	unidade.move( posicao );
    } 

    public void alteraTotalDeUnidades( int novoTotal ) {

	this.totalUnidades = novoTotal;
    }

    public int recuperaTotalDeUnidades() {

	return this.totalUnidades;
    }

    public void adicionaObservador( Observador observador ) {
	
	observadores.add( observador );
    }

    public void removeObservador( Observador observador ) {
    
	int i = observadores.indexOf( observador );
	if( i != -1 ) {
	    observadores.remove( i );
	}
    }

    protected void notificaObservadores( Object estado ) {
        
	Observador observador;
	for( int i = 0; i < observadores.size(); i++ ) {
	    observador = ( Observador ) observadores.get( i );
	    observador.atualiza( estado );
	}
    }
}
