import java.lang.Math;
import java.util.ArrayList;
import java.util.Collection;

public class PadraoDiamante implements PadraoDoEfeito {

    private static PadraoDiamante instancia;

    private PadraoDiamante() {
    }
    
    public static PadraoDiamante recuperaPadrao() {
        
        if( instancia == null ) {
            
            instancia = new PadraoDiamante();
        }
        return instancia;
    }

    public Collection calculaArea( int extensao ) {

        ArrayList retorno = new ArrayList();
        
        for( int i = -extensao; i <= extensao; i++ ) {
            int distancia = extensao - Math.abs( i );
            for( int j = -distancia; j <= distancia; j++ ) {
                retorno.add( new Coordenada( j, i ) );
            }
        }
        return retorno;
    }
}
