import java.io.File;
import java.util.Collection;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import java.awt.Image;

import javax.swing.JPanel;
import javax.swing.ImageIcon;
import javax.swing.JButton;

public class PainelControleMapa extends JPanel implements Observado {

    private PainelMapa mapa;

    public PainelControleMapa( Setor[][] mapa ) {
        
        super( new GridBagLayout() );

        this.mapa = new PainelMapa( mapa );

        inicializaComponentes();
    }

    public void inicializaComponentes() {

        GridBagConstraints gbc = new GridBagConstraints();
        

        gbc.fill = GridBagConstraints.BOTH;
        gbc.gridx = 0;
        gbc.weightx = 9;
        gbc.gridy = 0;
        gbc.weighty = 7;
        add( mapa, gbc );

        JPanel botoesVerticais = new JPanel( new GridBagLayout() );

        JButton botaoSobePagina = 
            new JButton( new ImageIcon( "imagens" +
                                        File.separator +
                                        "arrowup2.png" ) );
        
        botaoSobePagina.addActionListener( new ActionListener() {
                
                public void actionPerformed( ActionEvent e ) {
                    mapa.ajustaOrigemY( -6 );
                }                
            } );
        
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridx = 0;
        gbc.weightx = 1;
        gbc.gridy = 0;
        gbc.weighty = 1;

        botoesVerticais.add( botaoSobePagina, gbc );

        JButton botaoSobe = 
            new JButton( new ImageIcon( "imagens" +
                                        File.separator +
                                        "arrowup.png" ) );

        botaoSobe.addActionListener( new ActionListener() {
                
                public void actionPerformed( ActionEvent e ) {
                    mapa.ajustaOrigemY( -1 );
                }
                
            } );

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridx = 0;
        gbc.weightx = 1;
        gbc.gridy = 1;
        gbc.weighty = 1;

        botoesVerticais.add( botaoSobe, gbc );
        
        JPanel espacoVazio = new JPanel();

        gbc.fill = GridBagConstraints.BOTH;
        gbc.gridx = 0;
        gbc.weightx = 1;
        gbc.gridy = 2;
        gbc.weighty = 3;

        botoesVerticais.add( espacoVazio, gbc );
        
        JButton botaoDesce = 
            new JButton( new ImageIcon( "imagens" +
                                        File.separator +
                                        "arrowdown.png" ) );
        
        botaoDesce.addActionListener( new ActionListener() {
                
                public void actionPerformed( ActionEvent e ) {
                    mapa.ajustaOrigemY( 1 );
                }
            } );

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridx = 0;
        gbc.weightx = 1;
        gbc.gridy = 5;
        gbc.weighty = 1;

        botoesVerticais.add( botaoDesce, gbc );

        JButton botaoDescePagina = 
            new JButton( new ImageIcon( "imagens" +
                                        File.separator +
                                        "arrowdown2.png" ) );
        
        botaoDescePagina.addActionListener( new ActionListener() {
                
                public void actionPerformed( ActionEvent e ) {
                    mapa.ajustaOrigemY( 6 );
                }
            } );

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridx = 0;
        gbc.weightx = 1;
        gbc.gridy = 6;
        gbc.weighty = 1;
       
        botoesVerticais.add( botaoDescePagina, gbc );

        gbc.fill = GridBagConstraints.BOTH;
        gbc.gridx = 1;
        gbc.weightx = 1;
        gbc.gridy = 0;
        gbc.weighty = 1;

        add( botoesVerticais, gbc );

        JPanel botoesHorizontais = new JPanel( new GridBagLayout() );

        JButton botaoPaginaEsquerda = 
            new JButton( new ImageIcon( "imagens" +
                                        File.separator +
                                        "arrowleft2.png" ) );

        botaoPaginaEsquerda.addActionListener( new ActionListener() {
                
                public void actionPerformed( ActionEvent e ) {
                    mapa.ajustaOrigemX( -8 );
                }                
            } );

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridx = 0;
        gbc.weightx = 1;
        gbc.gridy = 0;
        gbc.weighty = 1;
  
        botoesHorizontais.add( botaoPaginaEsquerda, gbc );

        JButton botaoEsquerda = 
            new JButton( new ImageIcon( "imagens" +
                                        File.separator +
                                        "arrowleft.png" ) );
        
        botaoEsquerda.addActionListener( new ActionListener() {
                
                public void actionPerformed( ActionEvent e ) {
                    mapa.ajustaOrigemX( -1 );
                }                
            } );
        
        gbc.fill = GridBagConstraints.NONE;
        gbc.gridx = 1;
        gbc.weightx = 1;
        gbc.gridy = 0;
        gbc.weighty = 1;

        botoesHorizontais.add( botaoEsquerda, gbc );
        
        espacoVazio = new JPanel();

        gbc.fill = GridBagConstraints.BOTH;
        gbc.gridx = 2;
        gbc.weightx = 5;
        gbc.gridy = 1;
        gbc.weighty = 1;

        botoesHorizontais.add( espacoVazio, gbc );
        
        JButton botaoDireita = 
            new JButton( new ImageIcon( "imagens" +
                                        File.separator +
                                        "arrowright.png" ) );

        botaoDireita.addActionListener( new ActionListener() {
                
                public void actionPerformed( ActionEvent e ) {
                    mapa.ajustaOrigemX( 1 );
                }                
            } );

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridx = 7;
        gbc.weightx = 1;
        gbc.gridy = 0;
        gbc.weighty = 1;

        botoesHorizontais.add( botaoDireita, gbc );

        JButton botaoPaginaDireita = 
            new JButton( new ImageIcon( "imagens" +
                                        File.separator +
                                        "arrowright2.png" ) );

        botaoPaginaDireita.addActionListener( new ActionListener() {
                
                public void actionPerformed( ActionEvent e ) {
                    mapa.ajustaOrigemX( 8 );
                }                
            } );

        gbc.fill = GridBagConstraints.NONE;
        gbc.gridx = 8;
        gbc.weightx = 1;
        gbc.gridy = 0;
        gbc.weighty = 1;

        botoesHorizontais.add( botaoPaginaDireita, gbc );

        gbc.fill = GridBagConstraints.BOTH;
        gbc.gridx = 0;
        gbc.weightx = 1;
        gbc.gridy = 1;
        gbc.weighty = 1;

        add( botoesHorizontais, gbc );

    }

    public void alteraPermitidos( Collection permitidos ) {
	
	mapa.alteraPermitidos( permitidos );
    }

    public void alteraAfetados( Collection afetados ) {
	
	mapa.alteraAfetados( afetados );
    }

    public void adicionaObservador( Observador observador ) {
        
        mapa.adicionaObservador( observador );
    }

    public void removeObservador( Observador observador ) {
        
        mapa.removeObservador( observador );
    }

    public void alteraMapa( Setor[][] novoMapa ) {
        
        mapa.alteraMapa( novoMapa );
    }

    public void centraliza( int x, int y ) {
        
        mapa.centraliza( x, y );
    }
    
    public static void main( String[] args ) {
        
        javax.swing.JFrame jf = new javax.swing.JFrame( "teste painel" );
	

	java.awt.Toolkit tk = java.awt.Toolkit.getDefaultToolkit();

	String[] fundo = new String[3];

	fundo[0] = "agua.png";
	fundo[1] = "pedra.png";
	fundo[2] = "grama.png";
	Unidade viviUni = new Unidade( "vivi", 10, 10, 10, "vivisit.gif" );
	Unidade yuffieUni = new Unidade( "yuffie", 10, 10, 10, "yuffie.gif" );
	
	java.util.Random r = new java.util.Random();

	Setor[][] mapa = new Setor[9][11];

	for( int i = 0; i < 9; i++ ) {
	    for( int j = 0; j < 11; j++ ) {
		mapa[i][j] = new Setor( j, i );
		mapa[i][j].alteraFundo( fundo[ r.nextInt(3) ] );
	    }
	}
	
	mapa[ r.nextInt(9) ][ r.nextInt(11) ].alteraUnidade( viviUni );
	mapa[ r.nextInt(9) ][ r.nextInt(11) ].alteraUnidade( yuffieUni );

	PainelControleMapa pcm = new PainelControleMapa( mapa );

	java.util.ArrayList permitidos = new java.util.ArrayList();
	permitidos.add( new Coordenada( 1,1 ) );
	permitidos.add( new Coordenada( 2,1 ) );
	permitidos.add( new Coordenada( 3,1 ) );
	java.util.ArrayList afetados = new java.util.ArrayList();
	afetados.add( new Coordenada( 1,1 ) );
	afetados.add( new Coordenada( 0,0 ) );
	afetados.add( new Coordenada( -1,-1 ) );
	
	pcm.alteraPermitidos( permitidos );
	pcm.alteraAfetados( afetados );
        pcm.adicionaObservador( new Observador() {
                
                public void atualiza( Object estado ) {
                    
                    Coordenada coord = ( Coordenada ) estado; 
                    System.out.println( "( " + coord.recuperaX() +
                                        ", " +
                                        coord.recuperaY() + " )" );
                }
            } );

        jf.getContentPane().add( pcm );
        jf.pack();
        jf.show();
    }
}
