/**
 * 
 * @version 1.0
 * @author Alex Minoru Kusano & Marcos Roberto Yukio Koga
 */
public class Setor {

    /** referencia para a unidade que se encontra nesse no */
    private Unidade unidade;

    /** custo de unidades de movimento, isso representa a dificuldade 
     que uma unidade tem para se locomover nesse terreno */
    private int custoDeMovimento;

    private int x;
    
    private int y;

    private String fundo;

    public Setor( int x, int y ) {
	
        this( 1, x, y ); 
    }
    
    public Setor( int custoDeMovimento, int x, int y ) {
	
	this( null, custoDeMovimento, x, y );
    }

    public Setor( String fundo, int custoDeMovimento, int x, int y ) {
	
	this.fundo = fundo;
	this.custoDeMovimento = custoDeMovimento;
        this.x = x;
        this.y = y;
    }

    public void alteraCustoDeMovimento( int novoCusto ) {
    
        this.custoDeMovimento = novoCusto;
    }

    public int recuperaCustoDeMovimento() {
        
        return this.custoDeMovimento;
    }

    public void alteraFundo( String novoFundo ) {
	
	this.fundo = novoFundo;
    }

    public String recuperaFundo() {
	
	return this.fundo;
    }

    public boolean estaVazio() {
	
	return ( unidade == null );
    }

    public Unidade recuperaUnidade() {
    
	return unidade;
    }

    public void removeUnidade() {
	
	unidade = null;
    }

    /**
     * coloca uma unidade no n se ja nao houver uma
     * @param unidade unidade a ser inserida no n 
     * @return retorna verdadeiro se a unidade pode ser alterada com sucesso
     */
    public boolean alteraUnidade( Unidade unidade) {
	
	if( estaVazio() ) {
	    this.unidade = unidade;
	    return true;
	}
	else {
	    return false;
	}
    }


    /**** NOVO ****/
    public int recuperaX() {

	return this.x;
    }

    /**** NOVO ****/
    public int recuperaY() {

	return this.y;
    }


    public boolean equals( Object obj ) {

	if( getClass().isInstance(obj) ) {

	    Setor setor = (Setor) obj;
	    return( ( x == setor.recuperaX() ) && ( y == setor.recuperaY() ) );
	}

	return false;
    }
}

