import java.io.File;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.Toolkit;
import javax.swing.JPanel;

public class ViewSetor extends JPanel {
    
    public static Image imagemNaoPermitido = 
        Toolkit.getDefaultToolkit().getImage( "imagens" +
                                              File.separator +
                                              "npermitido.png" );
    public static Image imagemAfetado =
        Toolkit.getDefaultToolkit().getImage( "imagens" +
                                              File.separator +
					      "afetado.png" );

    private Image terreno;
    private Image unidade;

    private boolean permitido;
    private boolean afetado;

    public ViewSetor() {
        
        super();

        terreno = null;
        unidade = null;
        permitido = false;
        afetado = false;
    }

    public void atualiza() {
	
	update();
    }

    public void atualiza( String terreno, String unidade ) {

        Toolkit tk = Toolkit.getDefaultToolkit();
        if( terreno != null ) {
            this.terreno = tk.getImage( "imagens" + File.separator + 
                                        "fundos"  + File.separator + 
                                        terreno );
        }
        else {
            this.terreno = null;
        }
        if( unidade != null ) {
            this.unidade = tk.getImage( "imagens"  + File.separator +
                                        "unidades" + File.separator +
                                        unidade );
        }
        else {
            this.unidade = null;
        }
        update();
    }

    public void afetado( boolean b ) {
        
        this.afetado = b;
    }

    public boolean estaAfetado() {
	
	return this.afetado;
    }

    public void permitido( boolean b ) {
    
        this.permitido = b;
    }

    public boolean estaPermitido() {
	
	return this.permitido;
    }

    /**
     * metodo de pintura do painel
     * @param g objeto de pintura
     */
    protected void paintComponent( Graphics g ) {

        int w1, h1;
        h1 = this.getHeight();
        w1 = this.getWidth();

        if ( g != null ) {

            if( terreno != null ) {
                g.drawImage( terreno, 0, 0, w1, h1, this ); 
            }
	    else {
		g.clearRect( 0, 0, w1, h1 ); 
	    }
            if( unidade != null ) {
                int w2, h2;
                w2 = ( int ) h1 *
                    unidade.getWidth( this ) / unidade.getHeight( this );
                h2 = ( int ) w1 * 
                    unidade.getHeight( this ) / unidade.getWidth( this );
                if( h1 > h2 ){
                    g.drawImage( unidade, 0, ( h1 - h2 ) / 2, w1, h2, this );
                } 
                else{
                    g.drawImage( unidade, ( w1 - w2 ) / 2, 0, w2, h1, this );
                }
            }
	    if( !permitido ) {
		g.drawImage( ViewSetor.imagemNaoPermitido, 0, 0,
			     w1, h1, this );
	    }
            if( afetado ) {
		g.drawImage( ViewSetor.imagemAfetado, 0, 0,
                             w1, h1, this );
            }            
        }
    }

    /**
     * metodo de atualizacao da pintura do painel
     */
    protected void update(){
        update( getGraphics() );
    }

    public static void main( String[] args ) {
        
        javax.swing.JFrame jf = 
            new javax.swing.JFrame( );
        
        java.awt.Container c = jf.getContentPane();
        c.setLayout( new java.awt.GridLayout( 2, 3 ) );

        java.awt.Toolkit tk = java.awt.Toolkit.getDefaultToolkit();
        String f = "arrowleft2.png";
        String b = "";

        ViewSetor vs = new ViewSetor();
        vs.atualiza( null, null );
        c.add( vs );

        vs = new ViewSetor();
        vs.setBorder( javax.swing.BorderFactory.createLineBorder( 
                                  java.awt.Color.black ) );
        vs.permitido( true );
	vs.afetado( true );
        vs.atualiza( null, null );
        
        c.add( vs );
        
        vs = new ViewSetor();
        vs.afetado( true );
        vs.atualiza( b, f );

        javax.swing.JButton jb = new javax.swing.JButton();
        jb.setLayout( new java.awt.BorderLayout() );
        jb.add( vs , "Center" );
        jb.setBorder( javax.swing.BorderFactory.createLineBorder( 
                                  java.awt.Color.black ) );
        c.add( jb );

        jf.getContentPane().add( new javax.swing.JLabel( "normal" ) );
        jf.getContentPane().add( new javax.swing.JLabel( "permitido" ) );
        jf.getContentPane().add( new javax.swing.JLabel( "afetado" ) );

        jf.pack();
        jf.show();
        
    }

}
